-- phpMyAdmin SQL Dump
-- version 2.6.4-pl3
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Nov 26, 2005 at 04:08 PM
-- Server version: 4.1.11
-- PHP Version: 5.0.4
-- 
-- Database: `jinzora3`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `jz_album_track`
-- 

CREATE TABLE `jz_album_track` (
  `ID` int(11) NOT NULL auto_increment,
  `AlbumID` int(11) NOT NULL default '0',
  `TrackID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `fk_album_track_album_id` (`AlbumID`),
  KEY `fk_album_track_track_id` (`TrackID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Matches tracks to multiple artists' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_album_track`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_albums`
-- 

CREATE TABLE `jz_albums` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Description` longtext,
  `Image` longtext,
  `Year` int(4) default '0',
  `Playcount` int(11) NOT NULL default '0',
  `Rating` int(11) NOT NULL default '0',
  `AmazonID` varchar(254) default NULL,
  `Price` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all Albums' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_albums`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_artist_album`
-- 

CREATE TABLE `jz_artist_album` (
  `ID` int(11) NOT NULL auto_increment,
  `ArtistID` int(11) NOT NULL default '0',
  `AlbumID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `ArtistID` (`ArtistID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Matches Albums to multiple Artists' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_artist_album`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_artists`
-- 

CREATE TABLE `jz_artists` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Description` longtext,
  `Image` longtext,
  `Playcount` int(11) NOT NULL default '0',
  `Rating` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all Artists' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_artists`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_data`
-- 

CREATE TABLE `jz_data` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Value` varchar(254) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Table to store random data needed by Jinzora' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_data`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_genre_album`
-- 

CREATE TABLE `jz_genre_album` (
  `ID` int(11) NOT NULL auto_increment,
  `GenreID` int(11) NOT NULL default '0',
  `AlbumID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `GenreID` (`GenreID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Matches Albums to multiple Genres' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_genre_album`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_genre_artist`
-- 

CREATE TABLE `jz_genre_artist` (
  `ID` int(11) NOT NULL auto_increment,
  `GenreID` int(11) NOT NULL default '0',
  `ArtistID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY `GenreID` (`GenreID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Matches Artists to multiple Genres' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_genre_artist`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_genres`
-- 

CREATE TABLE `jz_genres` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Description` longtext,
  `Image` longtext,
  `Playcount` int(11) default '0',
  `Rating` int(11) default '0',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all Genres' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_genres`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_media_types`
-- 

CREATE TABLE `jz_media_types` (
  `ID` int(11) NOT NULL auto_increment,
  `Extension` varchar(4) NOT NULL default '',
  `Type` varchar(10) NOT NULL default '',
  `Header` text NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores the different media types and their headers' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_media_types`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_now_playing`
-- 

CREATE TABLE `jz_now_playing` (
  `ID` int(11) NOT NULL auto_increment,
  `TrackID` int(11) NOT NULL default '0',
  `UserID` int(11) NOT NULL default '0',
  `Time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores the Now Playing data' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_now_playing`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_now_viewing`
-- 

CREATE TABLE `jz_now_viewing` (
  `ID` int(11) NOT NULL auto_increment,
  `TrackID` int(11) NOT NULL default '0',
  `UserID` int(11) NOT NULL default '0',
  `Time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores the Now Viewing data' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_now_viewing`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_settings`
-- 

CREATE TABLE `jz_settings` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Value` varchar(254) NOT NULL default '',
  `Type` varchar(254) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all the Jinzora settings' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_settings`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_similar_albums`
-- 

CREATE TABLE `jz_similar_albums` (
  `ID` int(11) NOT NULL auto_increment,
  `AlbumID` int(11) NOT NULL default '0',
  `SimilarID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Links albums to other similar albums' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_similar_albums`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_similar_artists`
-- 

CREATE TABLE `jz_similar_artists` (
  `ID` int(11) NOT NULL auto_increment,
  `ArtistID` int(11) NOT NULL default '0',
  `SimilarID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Links artists to other similar artists' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_similar_artists`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_tracks`
-- 

CREATE TABLE `jz_tracks` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(254) NOT NULL default '',
  `Filepath` varchar(254) NOT NULL default '',
  `Hidden` char(1) default NULL,
  `Number` char(3) default NULL,
  `Bitrate` varchar(10) default NULL,
  `Frequency` varchar(10) default NULL,
  `Filesize` varchar(10) default NULL,
  `Length` varchar(10) default NULL,
  `Year` varchar(5) default NULL,
  `Extension` varchar(5) default NULL,
  `Lyrics` longtext,
  `Description` longtext,
  `Price` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all the information about tracks' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_tracks`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `jz_users`
-- 

CREATE TABLE `jz_users` (
  `ID` int(11) NOT NULL auto_increment,
  `Username` varchar(254) NOT NULL default '',
  `Password` varchar(254) NOT NULL default '',
  `Stream` tinyint(1) NOT NULL default '0',
  `Download` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores data about the users' AUTO_INCREMENT=1 ;

-- 
-- Dumping data for table `jz_users`
-- 

