<?php if (!defined(JZ_SECURE_ACCESS)) die ('Security breach detected.');
	/**
	* - JINZORA | Web-based Media Streamer -  
	* 
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* - Resources -
	* - Jinzora Author: Ross Carlson <ross@jasbone.com>
	* - Web: http://www.jinzora.org
	* - Documentation: http://www.jinzora.org/docs	
	* - Support: http://www.jinzora.org/forum
	* - Downloads: http://www.jinzora.org/downloads
	* - License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* - Contributors -
	* Please see http://www.jinzora.org/team.html
	* 
	* - Code Purpose -
	* Creates many of the different blocks that are used by the Slick interface
	*
	* @since 01.11.05
	* @author Ross Carlson <ross@jinzora.org>
	*/
	
	class jzBlocks extends jzBlockClass {
	  
		/**
		* Constructor for the class.
		* 
		* @author Ben Dodson
		* @version 12/22/04
		* @since 12/22/04
		*/
		function jzBlocks() {
		
		}
		
		/**
		* Shows the site news
		* 
		* @author Ross Carlson
		* @version 01/26/05
		* @since 01/26/05
		* @param $node the Node we are viewing
		*/
		function slickSiteNews($node){
		
			$news = $this->siteNews($node);
			if ($news == ""){return;}

			$this->blockHeader("Site News &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ");
			$this->blockBodyOpen();
			?>
			<table width="100%" cellpadding="2" cellspacing="0" border="0">
				<tr>
					<td width="33%">
						<?php
							// Now let's store the data
							echo $news;
						?>
					</td>
				</tr>
			</table>
			<?php
			$this->blockBodyClose();
			$this->blockSpacer();
		}
		
		/**
		* Shows the Slick formated chart system
		* 
		* @author Ross Carlson
		* @version 01/26/05
		* @since 01/26/05
		* @param $node The node we are viewing so we can filter
		*/
		function showSlickCharts($node,$types = false){
			global $album_name_truncate, $img_tiny_play, $display_charts; 
			
			// First let's make sure they even want the charts
			if ($display_charts <> "true"){return;}
			
			// Let's setup our objects
			$display = new jzDisplay();
			?>
			<table width="100%" cellpadding="3">
				<tr>
					<td valign="top" width="100%">
					<?php
						$title = word("Charts");
						if ($node->getName() <> ""){
							$title = word("Charts"). " :: ". $node->getName();
						}
						$this->blockHeader($title);
						$this->blockBodyOpen();
					?>
					<table width="100%" cellpadding="2" cellspacing="0" border="0">
						<tr>
							<?php
								$this->showCharts($node,$types);
							?>
						</tr>
					</table>
					<?php
						$this->blockBodyClose();
					?>
					</td>
				</tr>
			</table>
			<?php	
		}		
		
		
		/**
		* Draws the block space for the featured artist/album
		* 
		* @author Ross Carlson
		* @version 01/30/05
		* @since 01/30/05
		* @param object $node The node that we are looking at so we can filter
		*/
		function showFeaturedBlock($node){
		
			// First we need to know if this is going to display or not
			$featuredArtists = $node->getFeatured(distanceTo("artist",$node));
			$featuredAlbums = $node->getFeatured(distanceTo("album",$node));
			if (count($featuredArtists) == 0 and count($featuredAlbums) == 0){ return; }
			
			// Ok, we should display
			echo '<td valign="top" width="10%">';
			
			// Now let's show a featured artist
			if (count($featuredArtists) <> 0){
				$this->showFeatured($featuredArtists, 300);
				$this->blockSpacer();
			}
			
			// Now let's show a featured album
			if (count($featuredAlbums) <> 0){
				$this->showFeatured($featuredAlbums, 300);
				$this->blockSpacer();
			}
			
			// Now let's show the popular artists
			//$blocks->popularArtists();
			
			//$blocks->blockSpacer();
			
			// Now let's show the recommendations
			//$blocks->jinzoraRecommends();
			echo '</td>';
		}
	  
	  	/**
		* Draws the Featured Artist/Album Block
		* 
		* @author Ross Carlson
		* @version 01/19/05
		* @since 01/19/05
		* @param object $node The node that we are looking at so we can filter
		*/
		function showFeatured($featured, $truncate = 150, $slimDisplay = false){
			global $album_name_truncate, $img_tiny_play, $artist_truncate, $album_name_truncate, $cms_mode;
			
			// Let's set the featured width
			$featWidth = 250;
				
			// Should we just return?
			if (!is_array($featured)){return;}
			
			// Let's make sure there are featured items
			// Now let's grab the featured artists
			shuffle($featured);
			$item = $featured[0];
			if ($item == ""){return;}
			
			// Let's setup our objects
			$display = new jzDisplay();
									
			// Let's create our block
			if (!$slimDisplay){
				$title = word("Editors Pick"). ": ". $display->playLink($item, $img_tiny_play, $item->getName(), false, true). $display->link($item, $display->returnShortName($item->getName(),$artist_truncate), word("Browse"). ": ". $item->getName(), false, true);
				$this->blockHeader($title);
				$this->blockBodyOpen($featWidth);
			} else {
				$this->openInnerBlock(); 
				$featWidth = "100%";
			}
			
			// Now let's display the item name
			echo '<table width="'. $featWidth. '" cellpadding="3"><tr><td width="'. $featWidth. '">';
			// Now let's display the item image and short description
			if (($art = $item->getMainArt("75x75")) <> false) {
				$display->link($item, $display->returnImage($art,$item->getName(),75,75,"limit",false,false,"left","3","3"));
			}
			if ($cms_mode == "false"){
				echo '<span class="jz_artistDesc">';
			}
			
			if ($slimDisplay){
				echo $display->playLink($item, $img_tiny_play, $item->getName(), false, true);
				echo "<strong>". $display->link($item, $item->getName(), $item->getName(), false, true). "</strong>";
				echo " &nbsp; ";
			}
			
			// Should we display the artist?
			if ($item->getPType() == "album"){
				$parent = $item->getParent();
				echo $display->playLink($parent, $img_tiny_play, $parent->getName(), false, true);
				echo "<strong>". $display->link($parent, $parent->getName(), $parent->getName(), false, true). "</strong>";
				echo "<br>";
			}
			
			$desc_truncate = $truncate;
			$desc = $item->getDescription();
			echo $display->returnShortName($desc,$desc_truncate);
			if (strlen($desc) > $desc_truncate){
				$url_array = array();
				$url_array['jz_path'] = $item->getPath("String");
				$url_array['action'] = "popup";
				$url_array['ptype'] = "readmore";
				echo '<a href="'. urlize($url_array). '" onclick="openPopup(this, 450, 450); return false;"> - '. word("read more"). '</a>';
			}
			echo '</span>';
			echo '</td></tr></table>';
						
			// Let's close out
			if (!$slimDisplay){
				$this->blockBodyClose();
			} else {
				$this->closeInnerBlock(); 
			}
		}
			  
		/**
		* Draws the Jinzora Radio Block using the data from the current node
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		* @param object $node The object to create the radio from
		*/
		function slickRadioBlock($node){
			global $show_radio;
			
			// First do they even want this?
			if ($show_radio <> true){return;}
			if ($node->getAncestor("artist") === false) {
			  return;
			}
			$this->blockHeader(word("Jinzora Radio"));
			$this->blockBodyOpen();
			?>
			<table width="100%" cellpadding="2" cellspacing="0" border="0">
				<tr>
					<td width="100%">
						<?php
							$this->radioBlock($node);
						?>
					</td>
				</tr>
			</table>
			<?php
			$this->blockBodyClose();	
		}
		
		/**
		* Draws the Jinzora similar albums block
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		* @param string $artist The artist that we are getting similar artist data from
		* @param bolean $limit Should we limit how many results we get back
		*/
		function slickSimilarAlbumBlock($element, $limit = false){
			global $show_similar;
			
			// First do they even want this?
			if ($show_similar <> true){return;}

			$this->similarAlbumBlock($element, $limit);	
		}
	
		/**
		* Draws the Jinzora similar artist block
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		* @param string $artist The artist that we are getting similar artist data from
		* @param string $onlyMatches Should we only display artists that are actually in your collection
		* @param bolean $limit Should we limit how many results we get back
		*/
		function slickSimilarArtistBlock($artist, $onlyMatches = false, $limit = false){
			global $jzSERVICES, $album_name_truncate, $img_tiny_play, $show_similar;
			
			// First do they even want this?
			if ($show_similar <> true){return;}
			
			$this->similarArtistBlock($artist, $onlyMatches, $limit);
		}
		
		/**
		* Draws the Jinzora Recommends block
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function jinzoraRecommends(){
		  global $jzUSER;
			// Let's create and open our block
			$this->blockHeader("Recommended");
			$this->blockBodyOpen();
			
			// Now let's return the suggestions for this user
			$recoArray = $jzUSER->getRecommendations();
			
			?>
			<nobr>
	
			</nobr>
			<?php
			$this->blockBodyClose();
		}
		
		/**
		* Draws the Jinzora Popular Artists Block
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function popularArtists(){
			
			// Let's open and create our block
			$this->blockHeader("Popular Artists");
			$this->blockBodyOpen();	
			?>
			<nobr>
			<a href="">Miles Davis</a><br>
			<a href="">David Sanborn</a><br>
			<a href="">Dave Bruebeck</a><br>
			<a href="">Dave Matthews Band</a><br>
			<a href="">Dave Koz</a><br>
			<a href="">Miles Davis</a><br>
			</nobr>
			<?php
			$this->blockBodyClose();
		}
		
		/**
		* Draws the block that displays all tracks from an artist on the artist page
		* 
		* @author Ross Carlson
		* @version 01/13/05
		* @since 01/13/05
		* @param $node The node of the item we are viewing
		*/
		function displaySlickAllTracks($node){		
			$arr = array();
			$arr['jz_path'] = $node->getPath("String");
			$viewAll = '<a href="'. urlize($arr). '">'. word("View Sampler"). '</a>';
			$this->blockHeader($node->getName(). " ". word("Sampler"), $viewAll);
			$this->blockBodyOpen();
			$this->displayAllTracks($node);
			$this->blockBodyClose();
		}
		
		/**
		* Draws the block that displays a random sampling of tracks from an artist
		* 
		* @author Ross Carlson
		* @version 01/13/05
		* @since 01/13/05
		* @param $node The node of the item we are viewing
		*/
		function displaySlickSampler($node){	
			$arr = array();
			$arr['jz_path'] = $node->getPath("String");
			$arr['action'] = "viewalltracks";
			$viewAll = '<a href="'. urlize($arr). '">'. word("View All Tracks"). '</a>';
			
			$this->blockHeader($node->getName(). " ". word("Sampler"), $viewAll);
			$this->blockBodyOpen();
			$this->displaySampler($node);
			$this->blockBodyClose();
		}
	  
	  /**
		* Draws the header for the blocks
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		* @param string $title The title for the block
		* @param string $right The data that should go in the top right of the block
		*/
		function blockHeader($title = "", $right = ""){
			global $root_dir;
			?>
			<table width="100%" cellspacing="0">
				<tr>
					<td width="5" height="23" class="jz_main_block_topl"><font style="font-size:1px">&nbsp;</font></td>
					<td width="50%" height="23" class="jz_main_block_topm">
						<nobr>
						<strong><?php echo $title; ?></strong>
						</nobr>
					</td>
					<td width="50%" height="23" align="right" class="jz_main_block_topm">
						<nobr>
						<div align="right">
						<?php echo $right; ?>
						</div>
						</nobr>
					</td>
					<td width="5" height="23" class="jz_main_block_topr"><font style="font-size:1px">&nbsp;&nbsp;&nbsp;</font></td>
				</tr>
			</table>
			<?php
		}
		
		/**
		* Draws the opening of the table in a block, comes right after the header
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function blockBodyOpen(){
			?>
			<table width="100%" cellspacing="0"><tr><td colspan="4" width="100%" valign="top" class="jz_block_td">
			<table width="100%" cellpadding="2" cellspacing="0" border="0"><tr><td width="100%">
			<?php
		}
		
		/**
		* Draws the close of the table for a block
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function blockBodyclose(){
			?>
			</td></tr></table>
			</td></tr></table>
			<?php
		}
		
		/**
		* Draws a small spacer row between blocks
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function blockSpacer(){
			?><table width="100%" cellpadding="2" cellspacing="0" border="0"><tr><td width="100%" height="10"></td></tr></table><?php
		}
		
		
		/**
		* Draws the slick playlist bar
		* 
		* @author Ross Carlson
		* @version 01/11/05
		* @since 01/11/05
		*/
		function slickPlaylistBar(){
			global $jzUSER;
			
			if (!$jzUSER->getSetting('stream')){
				return;
			}
			
			$this->openInnerBlock();
			$this->playlistBar();
			$this->closeInnerBlock();			
		}
			
	
		/**
		 * Displays a table of the given tracks.
		 *
		 * @author Ross Carlson
		 * @version 11/30/04
		 * @since 01/11/05
		 * @param array $tracks The array of objects of each track
		 * @param $purpose The type of this track table. One of:
		 * generic|album|search|sample|sample-all
		 */
	  function trackTable($tracks, $purpose = false){
		global $media_dir, $jinzora_skin, $hierarchy, $album_name_truncate, $row_colors, 
		  $img_more, $img_email, $img_rate, $img_discuss, $num_other_albums, $enable_ratings, $this_site, 
		  $root_dir, $jzUSER, $hide_id3_comments,$max_song_length, $enable_discussion, $max_song_name_length, $show_lyrics_links, $img_play, $img_play_dis;					
	
		// Let's setup our objects
		$display = new jzDisplay();
		
		// Let's start our table
		?>
		<table width="100%" align="center" border="0" cellpadding="5" cellspacing="0">
		<?php
		// Now we need to get all the tracks
		foreach ($tracks as $track){
			$meta = $track->getMeta();
			
			// Now let's display the rows
			echo '<tr>';
			
			echo '<td width="1%">';
			echo $meta['number'];
			echo '</td>';
			
			echo '<td width="1%">';
			if ($jzUSER->getSetting('stream')){
				$descName = $meta['title'];
				$display->link($track, $img_play, $descName, "jz_track_table_songs_href"); 
			} else {
				echo $img_play_dis;
			}

			echo '</td>';
			
			echo '<td width="96%">';
			if (!$trackTruncate){
				$tName = $meta['title'];
			} else {
				$tName = returnItemShortName($meta['title'], $trackTruncate);
			}
			if ($jzUSER->getSetting('stream')){
				$descName = $meta['title'];
				$display->link($track, $tName, $descName, "jz_track_table_songs_href"); 
			} else {
				echo $tName;
			}
			echo '</td>';
			
			echo '<td width="1%" align="center">';
			echo "&nbsp;". convertSecMins($meta['length']). "&nbsp;";
			echo '</td>';
			
			echo '<td width="1%">';
			echo 'STARS';
			echo '</td>';
			
			echo '</tr>';
		}
		?>
		</table>
		<?php
	  }
	  
	  
	  /**
	   * Displays a table of the given nodes.
	   *
	   * @author Ross Carlson
	   * @version 11/30/04
	   * @since 11/30/04
	   * @param object $node The node that we are viewing
	   */
	  function nodeTable($nodes,$type=false){
		global $media_dir, $jinzora_skin, $hierarchy, $album_name_truncate, $row_colors, 
		  $img_more, $img_email, $img_rate, $img_discuss, $num_other_albums, $jzUSER;					
		
		if (sizeof($nodes) == 0) return;
		// Let's setup the new display object
		$display = &new jzDisplay();
		
		// Now let's setup the big table to display everything
		$i=0;
		  ?>
		  <table class="jz_track_table" width="100%" cellpadding="3" cellspacing="0" border="0">
		 <?php
		 foreach ($nodes as $child) {
		   ?>
		   <tr class="<?php echo $row_colors[$i]; ?>">
		   <?php
		   if ($type <> "search"){
		   ?>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <input class="jz_checkbox" type="checkbox" name="track-<?php echo $c; ?>" value="<?php echo $path; ?>">
		   </td>
		   <?php
		   }
		   ?>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <?php echo $display->downloadButton($child); ?>
		   </td>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <?php echo $display->playButton($child); ?>
		   </td>
		   <?php
		   	if ($jzUSER->getSetting('stream')) {
		   ?>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <a class="jz_track_table_songs_href" href=""><?php echo $img_email; ?></a>
		   </td>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <a class="jz_track_table_songs_href" href=""><?php echo $img_rate; ?></a>
		   </td>
		   <td width="1%" valign="top" class="jz_track_table_songs_td">
		   <a class="jz_track_table_songs_href" href=""><?php echo $img_discuss; ?></a>
		   </td>
		   <?php
		   	}
		   ?>
		   <td width="1%" align="center" valign="top" class="jz_track_table_songs_td">
		   <?php echo $metaData['number']; ?>
		   </td>
		   <td width="100%" valign="top" class="jz_track_table_songs_td">
		   <?php 
		   $parent = $child->getNaturalParent();
		   if ($parent->getLevel() > 0) {
			 $display->link($parent, $parent->getName("String"), $parent->getName(), "jz_track_table_songs_href"); 
			 echo " / ";
		   }
		   $display->link($child, $child->getName("String"), $child->getName(), "jz_track_table_songs_href"); 
		   ?></a>
		   </td>
		   <td width="12%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr>&nbsp;</nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr> &nbsp; &nbsp; </nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr></nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr> &nbsp;  &nbsp; </nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr> &nbsp;  </nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr> &nbsp;  &nbsp; </nobr>
		   </td>
		   <td width="10%" align="center" valign="top" class="jz_track_table_songs_td">
		   <nobr> &nbsp;  &nbsp; </nobr>
		   </td>
		   </tr>
		   <?php		
		   $i = 1 - $i; // cool trick ;)
		 }
		
		// Now let's set a field with the number of checkboxes that were here
		echo "</table><br>";
	  }
	
	
		/**
		* Displays the random albums block
		* @author Ross Carlson
		* @version 12/22/04
		* @since 12/22/04
		* @param object $node the node that we are looking at
		* @param string $level The level we are looking at, like a subartist
		*/
		function slickRandomAlbums(&$node, $level = ""){
			global  $show_album_art,$random_albums,$random_per_slot;
			
			// Should we show this?
			if ($show_album_art == "false"){return;}
			
			// Now let's get a random amount of albums with album art
			$artArray = $node->getSubNodes("nodes",distanceTo("album",$node),true,$random_albums*$random_per_slot,true);
			if (count($artArray) == 0){return;}
			?>
			<table width="100%" cellpadding="3">
				<tr>
					<td valign="top" width="100%">
					<?php						
						$title = word("Random Albums");
						if ($node->getName() <> ""){
							$title = word("Random Albums"). " :: ". $node->getName();
						}
						$url_array = array();
						$url_array['jz_path'] = $node->getPath("String");
						$url_array['action'] = "viewallart";
						$showLink = '<a href="'. urlize($url_array). '">'. word("View All Art"). '</a> &nbsp; ';

						$this->blockHeader($title, $showLink);
						$this->blockBodyOpen();
						$this->randomAlbums($node, $level, $artArray);
						$this->blockBodyClose();
					?>
					</td>
				</tr>
			</table> 
			<?php
		}					 
	}
?>